Filename Mapper maps source file name(s) to target file name(s).

Built-in mappers can be accessed by specifying they "type" attribute:

Custom mappers can be specified by providing a dot-path to a include_path-relative class:

author | Hans Lellelid
package | phing.types
version | $Id$

### Methods

## __construct()

    __construct(\Project $project)

### Parameters

#### $project

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()

## Create the classpath to be used when searching for component being defined

    createClasspath()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()

## Factory, returns inmplementation of file name mapper as new instance

    getImplementation()

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()

### Returns

`\Project`Reference to current porject object

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()

## Set the class name of the FileNameMapper to use.

    setClassname($classname)

### Parameters

#### $classname

## Set the classpath to be used when searching for component being defined

    setClasspath(\Path $classpath)

### Parameters

#### $classpath

`\Path`

An Path object containing the classpath.

## Reference to a classpath to use when loading the files.

    setClasspathRef(\Reference $r)

### Parameters

#### $r

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()

### Parameters

#### $desc

## Set the argument to FileNameMapper.setFrom

    setFrom($from)

### Parameters

#### $from

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Make this Mapper instance a reference to another Mapper.

    setRefid(\Reference $r) : void

You must not set any other attribute if you make it a reference.

### Parameters

#### $r

`\Reference`

## Set the argument to FileNameMapper.setTo

    setTo($to)

### Parameters

#### $to

## Set the type of FileNameMapper to use.

    setType($type)

### Parameters

#### $type

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()

## Performs the check for circular references and returns the referenced Mapper.

    getRef()

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked

##

    $classname

##

    $classpath

##

    $classpathId

##

    $from

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project

##

    $to

##

    $type